// Convert a 3D prtiner to a coil winding machine
// Project details on:
// https://homofaciens.de/technics-machines-Winding-Machine_en.htm

$fn = 100;

M3_hole = 3.5;
M3_nut_e = 6.3;
M4_hole = 4.5;
M5_hole = 5.5;
M6_hole = 6.5;
M5_nut_e = 8.79 + 0.3;
M6_nut_e = 11.05 + 0.3;
M8_nut_e = 14.38+1.5;

bb3_do = 10;

motor_e = 42;
motor_l = 40;
motor_m = 31;
motor_shaft = 5.5;
motor_shaft_shift = 4.9;

lp_screw_X1 = 20;
lp_screw_X2 = 170/2-15;
lp_screw_Y = 20;

//MotorSpindle();
translate([0, 22, 0]){
//  MotorSpindle(M3_hole, M3_hole);
}

translate([-52, 55, 0]){
//  WindingSpool();
}

translate([-2, 120, 0]){
//  SpoolHolder();
}
translate([2, 120, 0])mirror([1, 0, 0]){
//  SpoolHolder();
}

//SpoolHolderLarge();

//StepperMount();

//Inlett();

//WireGuide();
rotate([180, 0, 0])mirror([0, 0, 1]){
//  WireGuide();
}

//translate([0, 0, 170/2])rotate([0, 90, 0])
//LinkPlate();

DrumBrake();

module DrumBrake(){
  db_l = 250;
  db_w = 20;
  db_wall = 2;
  db_d = 15;
  db_hole = 5.5;
  
  
  difference(){
    union(){
      translate([0, 0, db_wall/2])
      cube(size=[db_l, db_w, db_wall], center=true);
      translate([db_l/2, 0, db_d/2]){
        rotate([90, 0, 0])
        cylinder(d=db_d, h=db_w, center=true);
      }
    }
    translate([db_l/2, 0, db_d/2]){
      rotate([90, 0, 0])
      cylinder(d=db_hole, h=db_w*1.1, center=true);
    }
    translate([10-db_l/2, 0, db_wall/2]){
      cylinder(d=db_hole, h=db_wall*1.1, center=true);
    }
  }
}

module SpoolHolderLarge(){
  shl_w = 150;
  shl_h = 150;
  shl_wall = 5;
  shl_edge = 20;
  
  shl_holder_d1 = 50;
  shl_holder_d2 = 5;
  shl_holder_h = 40;
  
  
  // Spindle holder
  translate([-20, 0, shl_holder_h/2]){
    difference(){
      cylinder(d1=shl_holder_d1, d2=shl_holder_d2, h=shl_holder_h, center=true);
      
      cylinder(d=M3_hole, h=shl_holder_h*1.1, center=true);
    }
  }
  
  
  // Triangle
  difference(){
    union(){
      hull(){
        translate([-shl_h/2, shl_w/2, shl_wall/2]){
          cylinder(d=15, h=shl_wall, center=true);
        }
        translate([-shl_h/2, -shl_w/2, shl_wall/2]){
          cylinder(d=15, h=shl_wall, center=true);
        }
        translate([shl_h/2, 0, shl_wall/2]){
          cylinder(d=15, h=shl_wall, center=true);
        }
      }

      translate([-shl_h/2, shl_w/2, shl_wall/2]){
        cylinder(d=25, h=shl_wall, center=true);
      }
      translate([-shl_h/2, -shl_w/2, shl_wall/2]){
        cylinder(d=25, h=shl_wall, center=true);
      }
    }
    
    hull(){
      translate([(shl_edge-shl_h)/2, shl_w/2-shl_edge, shl_wall/2]){
        cylinder(d=1, h=shl_wall*1.1, center=true);
      }
      translate([(shl_edge-shl_h)/2, shl_edge-shl_w/2, shl_wall/2]){
        cylinder(d=1, h=shl_wall*1.1, center=true);
      }
      translate([shl_h/2-shl_edge, 0, shl_wall/2]){
        cylinder(d=1, h=shl_wall*1.1, center=true);
      }
    }

    translate([shl_h/2, 0, shl_wall/2+1]){
      cylinder(d=bb3_do, h=shl_wall, center=true);
    }
    translate([shl_h/2, 0, shl_wall/2-1]){
      cylinder(d=bb3_do-4, h=shl_wall, center=true);
    }
    
    translate([-shl_h/2, -shl_w/2, shl_wall/2]){
      cylinder(d=5, h=shl_wall*1.1, center=true);
    }

    translate([-shl_h/2, shl_w/2, shl_wall/2]){
      cylinder(d=5, h=shl_wall*1.1, center=true);
    }

  }
}


module StepperMount(){
  mm_wall = 2;
  mm_l = 47;
  mm_w = 50;
  mm_center_1 = 24;  
  bp_m_dis_2 = 0;
  bp_m_dis = 0;
  mm_h = 42 + mm_wall;
  mm_flap = 15;
  
  difference(){
    union(){
      // Motor plate
      translate([0, 0, mm_w/2])rotate([90, 0, 0])
      difference(){
        roundedRect([mm_l, mm_w, mm_wall], 5, [0,0,0,0]);
        translate([0, 0, mm_wall/2]){
          cylinder(d=mm_center_1, h=mm_wall*1.1, center=true);
        }
        for(j=[0:1:1])mirror([j,0,0])
        for(i=[0:1:1])mirror([0,i,0]){
          translate([bp_m_dis_2/2, bp_m_dis/2, mm_wall/2]){
            cylinder(d=M3_hole, h=mm_wall*1.1, center=true);
          }
          translate([motor_m/2, motor_m/2, mm_wall/2]){
            cylinder(d=M3_hole, h=mm_wall*1.1, center=true);
          }
        }
      }
      for(i=[0:1:1])mirror([i,0,0]){
        translate([mm_l/2, mm_h/2-mm_wall, mm_w/2])
        cube(size=[mm_wall, mm_h, mm_w], center=true);
        translate([(mm_flap + mm_l)/2, mm_h-mm_wall*1.5, mm_w/2])
        cube(size=[mm_flap, mm_wall, mm_w], center=true);

        hull(){
          translate([-19, -1, mm_wall/2]){
            cube(size=[10, mm_wall, mm_wall], center=true);
          }
          translate([(mm_flap + mm_l)/2, mm_h-mm_wall*1.5, mm_wall/2]){
            cube(size=[mm_flap, mm_wall, mm_wall], center=true);
          }
        }
      }
      
    }
  }
  
  
}

module SpoolHolder(){
  sh_wall = 2;
  sh_wall_2 = 5;
  sh_pivot = 70;
  sh_pivot_shift = 100;
  sh_w = 50;
  sh_w2 = 80;
  
  a = 1;
  
  translate([0, 0, sh_wall_2/2]){
    difference(){
      union(){
        hull(){
          translate([-a/2, 0, 0]){
            cube(size=[a, sh_w, sh_wall_2], center=true); 
          }
          translate([-sh_pivot, sh_pivot_shift, 0]){
            cylinder(d=20, h=sh_wall_2, center=true);
          }
        }
        translate([0, 0, 10-sh_wall_2/2]){
          cube(size=[sh_wall, sh_w2, 20], center=true); 
          hull(){
            translate([-10, 5.5, -9.5]){
              cube(size=[20, sh_wall, 1], center=true); 
            }
            translate([-2.5, 5.5, 9.5]){
              cube(size=[5, sh_wall, 1], center=true); 
            }
          }
        }
      }
      // Ball bearing pivot point
      translate([-sh_pivot, sh_pivot_shift, 0]){
        cylinder(d=bb3_do-4, h=sh_wall_2*1.1, center=true);
        translate([0, 0, -2]){
          hull(){
            cylinder(d=bb3_do, h=sh_wall_2, center=true);
            cylinder(d=bb3_do-4, h=sh_wall_2+4, center=true);
          }
        }
      }

    }
  }
  
  
}

module LinkPlate(){
  lp_l = 165;
  lp_w = 55;
  lp_h = 2;
  
  difference(){
    roundedRect([lp_l, lp_w, lp_h], 5);
    for(i=[0:1:1])mirror([0, i, 0]){
      for(j=[0:1:1])mirror([j, 0, 0]){
        translate([0, 0, lp_h/2]){
          translate([lp_screw_X1, lp_screw_Y, 0]){
            cylinder(d1=M3_hole, d2=8, h=lp_h+0.1, center=true);
          }
          translate([lp_screw_X2, lp_screw_Y, 0]){
            cylinder(d1=M3_hole, d2=8, h=lp_h+0.1, center=true);
          }
        }
      }
    }
  }
}

module WireGuide(){
  wg_l = 170/2;
  wg_gap_l = 30;
  wg_gap_h = 56;
  wg_wall = 2;
  wg_wall_2 = 5;
  wg_pivot = 60 + wg_gap_l/2;
  
  rm_l = 60;
  rm_h = 90;
  rm_d = M3_hole;
  rm_dx = 5;
  rm_dy = 5;
  
  a = wg_gap_l + 2 * wg_wall;
  b = wg_gap_h + 2 * wg_wall;
  
  
  
  translate([0, 0, wg_l/2])
  difference(){
    union(){
      hull(){
        cube(size=[a, b, wg_l], center=true);
        translate([0, -10, 0]){
          cube(size=[5, b, wg_l], center=true);
        }
      }
      // Rods mount plate
      difference(){
        translate([-12.5, 5, -wg_l/2]){
          difference(){
            roundedRect([rm_l, rm_h, wg_wall], 2.5);
            for(j=[rm_dy/2-rm_h/2:rm_dy:rm_h/2]){
              for(i=[rm_dx/2-rm_l/2:rm_dx:rm_l/2]){
                translate([i, j, 0]){
                  cylinder(d=rm_d, h=wg_wall * 2.1, center=true);
                }
              }
            }
          }
        }
      }
    }

      for(i=[0:1:1])mirror([0, i, 0]){
        translate([0, 0, 0]){
          translate([0, lp_screw_Y, wg_l/2-lp_screw_X1])
          rotate([0, 90, 0]){
            cylinder(d=M3_hole, h=1000.1, center=true);
          }
          translate([0, lp_screw_Y, wg_l/2-lp_screw_X2])
          rotate([0, 90, 0]){
            cylinder(d1=M3_hole, d2=8, h=1000.1, center=true);
          }
        }
      }


    // Mount screws
    for(i=[0:1:1])mirror([0, 0, i])
    translate([0, -20, wg_l/2-15]){
      rotate([90, 0, 0]){
        cylinder(d=M3_hole, h = b, center=true);
        cylinder(d=M3_nut_e, h = b-30, center=true, $fn=6);
      }
    }
    
    // Inner cuts
    cube(size=[wg_gap_l, wg_gap_h, wg_l*1.1], center=true);
    translate([10, 0, 0]){
      cube(size=[wg_gap_l, wg_gap_h-5, wg_l*1.1], center=true);
    }
  }
  
}

module Inlett(){
  wg_l = 170/2;
  tolerance = 0.5;
  i_l = 170;
  i_w = 56 - tolerance;
  i_h = 30 - tolerance - 2;
  i_gap_h = 23;
  i_gap_w1 = 20;
  i_gap_l2 = 110;
  i_gap_w2 = 40;
  cut_w = 2;
    
  
  translate([0, 0, i_h/2])
  difference(){
    cube(size=[i_l, i_w, i_h], center=true);
    translate([0, 0, (i_h-i_gap_h)/2+.1])
    cube(size=[i_l*1.1, i_gap_w1, i_gap_h], center=true);
    translate([i_gap_l2, 0, (i_h-i_gap_h)/2+.1])
    cube(size=[i_l*1.1, i_gap_w2, i_gap_h], center=true);
    
    cube(size=[i_l*1.1, cut_w, i_h*1.1], center=true);
  }
  
}

module WindingSpool(){
  ws_d1 = 40;
  ws_d2 = 100;
  ws_wall = 2;
  ws_h = 60;
  translate([0, 0, ws_h/2]){
    translate([ws_d2+5, 0, (ws_wall-ws_h)/2]){
      difference(){
        cylinder(d=ws_d2, h=ws_wall, center=true);
        cylinder(d=M3_hole, h=ws_wall*1.1, center=true);
        for(i=[0:60:360])rotate([0, 0, i]){
          translate([15, 0, 0]){
            cylinder(d=M3_hole, h=ws_wall*1.1, center=true);
          }
        }
        difference(){
          cylinder(d=ws_d2-10, h=ws_wall*1.1, center=true);
          cylinder(d=ws_d1+0.1, h=ws_wall*1.1, center=true);
          for(i=[0:30:360])rotate([0, 0, i]){
            cube(size=[ws_d2, 5, ws_wall*1.1], center=true);
          }
        }
      }
    }
    difference(){
      union(){
        cylinder(d=ws_d1, h=ws_h, center=true);
        translate([0, 0, (ws_wall-ws_h)/2]){
          cylinder(d=ws_d2, h=ws_wall, center=true);
        }
      }
      cylinder(d=M3_hole, h=ws_h*1.1, center=true);
      for(i=[0:60:360])rotate([0, 0, i]){
        translate([15, 0, ws_h/2]){
          cylinder(d=2.5, h=50, center=true);
        }
      }
      translate([0, 0, (ws_wall-ws_h)/2]){
        difference(){
          cylinder(d=ws_d2-10, h=ws_wall*1.1, center=true);
          cylinder(d=ws_d1+0.1, h=ws_wall*1.1, center=true);
          for(i=[0:30:360])rotate([0, 0, i]){
            cube(size=[ws_d2, 5, ws_wall*1.1], center=true);
          }
        }
      }
    }
  }
}

module MotorSpindle(hole1 = 3, hole2 = 5){
  ms_hole_1 = hole1;
  ms_hole_2 = hole2;
  ms_d1 = 20;
  ms_d2 = 5;
  ms_h1 = 20;
  ms_h2 = 10;
  
  translate([0, 0, ms_h2+ms_h1/2])
  difference(){
    union(){
      cylinder(d1 = ms_d1, d2 = ms_d2, h = ms_h1, center=true);
      translate([0, 0, (-ms_h1 - ms_h2)/2]){
        cylinder(d = ms_d1, h = ms_h2, center=true);
      }
    }
    translate([0, 0, (-ms_h1-ms_h2)/2]){
      hull(){
        cylinder(d = ms_hole_2, h = ms_h2 + 20, center=true);
        cylinder(d = ms_hole_1, h = ms_h2 + 25, center=true);
      }
    }
    cylinder(d = ms_hole_1, h = (ms_h1+ms_h2)*2.1, center=true);
    translate([0, 0, (-ms_h1 - ms_h2)/2])rotate([90, 0, 0]){
      cylinder(d = M3_hole, h = ms_d1*1.1, center=true);
    }
    translate([0, 6, (-ms_h1 - ms_h2)/2]){
      hull(){
        translate([0, 0, 1])
        rotate([90, 0, 0])rotate([0, 0, 30]){
          cylinder(d = M3_nut_e, h = 3.5, center=true, $fn=6);
        }
        translate([0, 0, -20])
        rotate([90, 0, 0])rotate([0, 0, 30]){
          cylinder(d = M3_nut_e, h = 3.5, center=true, $fn=6);
        }
      }
    }
  }
  
}

module roundedRect(size, radius, edges=[1, 1, 1, 1], vscale=[1,1], shift=0){
  x = size[0];
  y = size[1];
  z = size[2];

  translate([0, -shift*2, 0]){
    linear_extrude(height=z, scale=[vscale[0], vscale[1]]){
      translate([0, shift*2, 0]){
        hull(){
            // place 4 circles in the corners, with the given radius
            if(edges[0]){
              translate([(-x/2)+(radius), (-y/2)+(radius), 0])
              circle(r=radius);
            }
            else{
              translate([(-x/2)+(radius/2), (-y/2)+(radius/2), 0])
              square(size=[radius, radius], center=true);
            }
            if(edges[1]){
              translate([(x/2)-(radius), (-y/2)+(radius), 0])
              circle(r=radius);
            }
            else{
              translate([(x/2)-(radius/2), (-y/2)+(radius/2), 0])
              square(size=[radius, radius], center=true);
            }

            if(edges[2]){
              translate([(-x/2)+(radius), (y/2)-(radius), 0])
              circle(r=radius);
            }
            else{
              translate([(-x/2)+(radius/2), (y/2)-(radius/2), 0])
              square(size=[radius, radius], center=true);
            }

            if(edges[3]){
              translate([(x/2)-(radius), (y/2)-(radius), 0])
              circle(r=radius);
            }
            else{
              translate([(x/2)-(radius/2), (y/2)-(radius/2), 0])
              square(size=[radius, radius], center=true);
            }
          }
       }
    }
  }
}
